diff --git a/doc/NEWS b/doc/NEWS
index 1e21d4d3d5..c8a9519a12 100644
--- a/doc/NEWS
+++ b/doc/NEWS
@@ -75,6 +75,9 @@ Major changes from 1.9.0-jumbo-1 (May 2019) in this bleeding-edge version:
 - Worked out a new KISS solution "FMT_BLOB" for non-hash formats, so they can
   still benefit from same-salt optimizations/exploits.  [magnum; 2019]
 
+- Converted WPAPSK formats to the new FMT_BLOB scheme, with excellent
+  improvement in performance, especially for single mode.  [magnum; 2019]
+
 
 Major changes from 1.8.0-jumbo-1 (December 2014) to 1.9.0-jumbo-1 (May 2019):
 
diff --git a/run/opencl/wpapsk_kernel.cl b/run/opencl/wpapsk_kernel.cl
index 631ed23b3b..5f6ff50b6f 100644
--- a/run/opencl/wpapsk_kernel.cl
+++ b/run/opencl/wpapsk_kernel.cl
@@ -1,6 +1,6 @@
 /*
  * This software is Copyright (c) 2012 Lukas Odzioba <ukasz at openwall.net>,
- * Copyright (c) 2012 Milen Rangelov and Copyright (c) 2012-2017 magnum,
+ * Copyright (c) 2012 Milen Rangelov and Copyright (c) 2012-2019 magnum,
  * and it is hereby released to the general public under the following terms:
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted.
@@ -17,11 +17,14 @@ typedef struct {
 } mic_t;
 
 typedef struct {
-	uint  length;
-	uint  eapol[(256 + 64) / 4];
-	uint  eapol_size;
-	uint  data[(64 + 12) / 4]; // pre-processed mac and nonce
-	uchar salt[36]; // essid
+	uint32_t eapol_size;
+	uint32_t eapol[(256 + 64) / 4];
+	uint32_t data[(64 + 12) / 4]; /* EAPOL data or PMKID */
+} wpapsk_data;
+
+typedef struct {
+	uint32_t length;
+	uint8_t  essid[36]; // essid
 } wpapsk_salt;
 
 typedef struct {
@@ -112,7 +115,7 @@ void wpapsk_init(__global const MAYBE_VECTOR_UINT *inbuffer,
 	preproc(&inbuffer[gid * 16], state[gid].opad, 0x5c5c5c5c);
 
 	hmac_sha1(state[gid].out, state[gid].ipad, state[gid].opad,
-	          salt->salt, salt->length, 0x01);
+	          salt->essid, salt->length, 0x01);
 
 	for (i = 0; i < 5; i++)
 		state[gid].W[i] = state[gid].out[i];
@@ -178,7 +181,7 @@ void wpapsk_pass2(MAYBE_CONSTANT wpapsk_salt *salt,
 	for (i = 0; i < 5; i++)
 		state[gid].out[i] = VSWAP32(state[gid].out[i]);
 
-	hmac_sha1(state[gid].out, state[gid].ipad, state[gid].opad, salt->salt, salt->length, 0x02);
+	hmac_sha1(state[gid].out, state[gid].ipad, state[gid].opad, salt->essid, salt->length, 0x02);
 
 	for (i = 0; i < 5; i++)
 		state[gid].W[i] = state[gid].out[i];
@@ -249,7 +252,7 @@ inline void prf_512(const MAYBE_VECTOR_UINT *key,
 __kernel
 __attribute__((vec_type_hint(MAYBE_VECTOR_UINT)))
 void wpapsk_final_md5(__global wpapsk_state *state,
-                      MAYBE_CONSTANT wpapsk_salt *salt,
+                      MAYBE_CONSTANT wpapsk_data *data,
                       __global mic_t *mic)
 {
 	uint gid = get_global_id(0);
@@ -258,7 +261,7 @@ void wpapsk_final_md5(__global wpapsk_state *state,
 	MAYBE_VECTOR_UINT W[16];
 	MAYBE_VECTOR_UINT ipad[4], opad[4];
 	uint i, eapol_blocks;
-	MAYBE_CONSTANT uint *cp = salt->eapol;
+	MAYBE_CONSTANT uint *cp = data->eapol;
 
 	for (i = 0; i < 5; i++)
 		outbuffer[i] = state[gid].partial[i];
@@ -266,7 +269,7 @@ void wpapsk_final_md5(__global wpapsk_state *state,
 	for (i = 0; i < 3; i++)
 		outbuffer[5 + i] = state[gid].out[i];
 
-	prf_512(outbuffer, salt->data, prf);
+	prf_512(outbuffer, data->data, prf);
 
 	// HMAC(md5(), prf, 16, hccap.eapol, hccap.eapol_size, mic[gid].keymic, NULL);
 	// prf is the key (16 bytes)
@@ -279,8 +282,8 @@ void wpapsk_final_md5(__global wpapsk_state *state,
 	md5_block(MAYBE_VECTOR_UINT, W, ipad); /* md5_update(ipad, 64) */
 
 	/* eapol_blocks (of MD5),
-	 * eapol data + 0x80, null padded and len set in set_salt() */
-	eapol_blocks = 1 + (salt->eapol_size + 8) / 64;
+	 * eapol data + 0x80, null padded and len set in cmp_all() */
+	eapol_blocks = 1 + (data->eapol_size + 8) / 64;
 
 	/* At least this will not diverge */
 	while (eapol_blocks--) {
@@ -345,7 +348,7 @@ void wpapsk_final_md5(__global wpapsk_state *state,
 __kernel
 __attribute__((vec_type_hint(MAYBE_VECTOR_UINT)))
 void wpapsk_final_sha1(__global wpapsk_state *state,
-                       MAYBE_CONSTANT wpapsk_salt *salt,
+                       MAYBE_CONSTANT wpapsk_data *data,
                        __global mic_t *mic)
 {
 	MAYBE_VECTOR_UINT outbuffer[8];
@@ -355,7 +358,7 @@ void wpapsk_final_sha1(__global wpapsk_state *state,
 	MAYBE_VECTOR_UINT ipad[5];
 	MAYBE_VECTOR_UINT opad[5];
 	uint i, eapol_blocks;
-	MAYBE_CONSTANT uint *cp = salt->eapol;
+	MAYBE_CONSTANT uint *cp = data->eapol;
 
 	for (i = 0; i < 5; i++)
 		outbuffer[i] = state[gid].partial[i];
@@ -363,7 +366,7 @@ void wpapsk_final_sha1(__global wpapsk_state *state,
 	for (i = 0; i < 3; i++)
 		outbuffer[5 + i] = state[gid].out[i];
 
-	prf_512(outbuffer, salt->data, prf);
+	prf_512(outbuffer, data->data, prf);
 
 	// HMAC(sha1(), prf, 16, hccap.eapol, hccap.eapol_size, mic[gid].keymic, NULL);
 	// prf is the key (16 bytes)
@@ -375,8 +378,8 @@ void wpapsk_final_sha1(__global wpapsk_state *state,
 	sha1_single(MAYBE_VECTOR_UINT, W, ipad);
 
 	/* eapol_blocks (of SHA1),
-	 * eapol data + 0x80, null padded and len set in set_salt() */
-	eapol_blocks = 1 + (salt->eapol_size + 8) / 64;
+	 * eapol data + 0x80, null padded and len set in cmp_all() */
+	eapol_blocks = 1 + (data->eapol_size + 8) / 64;
 
 	/* At least this will not diverge */
 	while (eapol_blocks--) {
@@ -440,7 +443,7 @@ void wpapsk_final_sha1(__global wpapsk_state *state,
 __kernel
 __attribute__((vec_type_hint(MAYBE_VECTOR_UINT)))
 void wpapsk_final_pmkid(__global wpapsk_state *state,
-                        MAYBE_CONSTANT wpapsk_salt *salt,
+                        MAYBE_CONSTANT wpapsk_data *data,
                         __global mic_t *mic)
 {
 	MAYBE_VECTOR_UINT outbuffer[8];
@@ -449,7 +452,7 @@ void wpapsk_final_pmkid(__global wpapsk_state *state,
 	MAYBE_VECTOR_UINT ipad[5];
 	MAYBE_VECTOR_UINT opad[5];
 	uint i;
-	MAYBE_CONSTANT uint *cp = salt->data;
+	MAYBE_CONSTANT uint *cp = data->data;
 
 	for (i = 0; i < 5; i++)
 		outbuffer[i] = state[gid].partial[i];
@@ -652,7 +655,7 @@ sha256_prf_bits(const uchar *key, uint key_len, MAYBE_CONSTANT uchar *data,
 
 __kernel
 void wpapsk_final_sha256(__global wpapsk_state *state,
-                         MAYBE_CONSTANT wpapsk_salt *salt,
+                         MAYBE_CONSTANT wpapsk_data *data,
                          __global mic_t *mic)
 {
 	uchar ptk[48];
@@ -668,12 +671,12 @@ void wpapsk_final_sha256(__global wpapsk_state *state,
 	for (i = 0; i < 3; i++)
 		outbuffer[5 + i] = SWAP32(state[gid].out[i]);
 
-	sha256_prf_bits((uchar*)outbuffer, 32, (MAYBE_CONSTANT uchar*)salt->data, 76, ptk, 48 * 8);
+	sha256_prf_bits((uchar*)outbuffer, 32, (MAYBE_CONSTANT uchar*)data->data, 76, ptk, 48 * 8);
 
 	/* CMAC is kinda like a HMAC but using AES */
 	AES_CMAC_Init(&ctx);
 	AES_CMAC_SetKey(&ctx, ptk);
-	AES_CMAC_Update(&ctx, (MAYBE_CONSTANT uchar*)salt->eapol, salt->eapol_size);
+	AES_CMAC_Update(&ctx, (MAYBE_CONSTANT uchar*)data->eapol, data->eapol_size);
 	AES_CMAC_Final(cmic, &ctx);
 
 	/* We only use 16 bytes */
diff --git a/src/opencl_wpapmk_fmt_plug.c b/src/opencl_wpapmk_fmt_plug.c
index e28240bdd9..2e603f60b7 100644
--- a/src/opencl_wpapmk_fmt_plug.c
+++ b/src/opencl_wpapmk_fmt_plug.c
@@ -1,5 +1,5 @@
 /*
- * This software is Copyright (c) 2017-2018 magnum,
+ * This software is Copyright (c) 2017-2019 magnum,
  * and it is hereby released to the general public under the following terms:
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted.
@@ -22,12 +22,12 @@ john_register_one(&fmt_opencl_wpapsk_pmk);
 #include "options.h"
 #include "opencl_common.h"
 
-static cl_mem mem_in, mem_out, mem_salt, mem_state, pinned_in, pinned_out;
+static cl_mem mem_in, mem_state, mem_out, mem_data;
+static cl_mem pinned_in, pinned_out;
 static cl_kernel wpapmk_init, wpapsk_final_md5, wpapsk_final_sha1, wpapsk_final_sha256, wpapsk_final_pmkid;
 static size_t key_buf_size;
 static unsigned int *inbuffer;
 static struct fmt_main *self;
-static int new_keys;
 
 #define JOHN_OCL_WPAPSK
 #define WPAPMK
@@ -61,8 +61,11 @@ typedef struct {
 	cl_uint partial[5];
 } wpapsk_state;
 
+extern mic_t *mic;
+extern hccap_t hccap;
+
 static const char * warn[] = {
-	"xfer: ", ", init: ", ", final: ", ", xfer: "
+	"xfer: ", ", init: ", ", blob_xfer: ", ", final: ", ", xfer: "
 };
 
 static int split_events[] = { -1, -1, -1 };
@@ -80,6 +83,7 @@ static size_t get_task_max_work_group_size()
 	s = MIN(s, autotune_get_task_max_work_group_size(FALSE, 0, wpapsk_final_sha1));
 	s = MIN(s, autotune_get_task_max_work_group_size(FALSE, 0, wpapsk_final_sha256));
 	s = MIN(s, autotune_get_task_max_work_group_size(FALSE, 0, wpapsk_final_pmkid));
+
 	return s;
 }
 
@@ -100,8 +104,8 @@ static void create_clobj(size_t gws, struct fmt_main *self)
 	mem_state = clCreateBuffer(context[gpu_id], CL_MEM_READ_WRITE, sizeof(wpapsk_state) * gws, NULL, &ret_code);
 	HANDLE_CLERROR(ret_code, "Error allocating mem_state");
 
-	mem_salt = clCreateBuffer(context[gpu_id], CL_MEM_READ_ONLY | CL_MEM_COPY_HOST_PTR, sizeof(wpapsk_salt), &currentsalt, &ret_code);
-	HANDLE_CLERROR(ret_code, "Error allocating mem setting");
+	mem_data = clCreateBuffer(context[gpu_id], CL_MEM_READ_ONLY | CL_MEM_ALLOC_HOST_PTR, sizeof(wpapsk_data), NULL, &ret_code);
+	HANDLE_CLERROR(ret_code, "Error allocating mem data");
 
 	pinned_out = clCreateBuffer(context[gpu_id], CL_MEM_WRITE_ONLY | CL_MEM_ALLOC_HOST_PTR, sizeof(mic_t) * gws, NULL, &ret_code);
 	HANDLE_CLERROR(ret_code, "Error allocating pinned out");
@@ -114,19 +118,19 @@ static void create_clobj(size_t gws, struct fmt_main *self)
 	HANDLE_CLERROR(clSetKernelArg(wpapmk_init, 1, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 }
 
@@ -141,7 +145,7 @@ static void release_clobj(void)
 		HANDLE_CLERROR(clReleaseMemObject(pinned_out), "Release pinned_out");
 		HANDLE_CLERROR(clReleaseMemObject(mem_in), "Release pinned_in");
 		HANDLE_CLERROR(clReleaseMemObject(mem_out), "Release mem_out");
-		HANDLE_CLERROR(clReleaseMemObject(mem_salt), "Release mem_salt");
+		HANDLE_CLERROR(clReleaseMemObject(mem_data), "Release mem_data");
 		HANDLE_CLERROR(clReleaseMemObject(mem_state), "Release mem state");
 		mem_state = NULL;
 	}
@@ -172,7 +176,6 @@ static void set_key(char *key, int index)
 		((unsigned char*)inbuffer)[GETPOS(i, index)] =
 			(atoi16[ARCH_INDEX(key[i << 1])] << 4) |
 			atoi16[ARCH_INDEX(key[(i << 1) + 1])];
-	new_keys = 1;
 }
 
 static char* get_key(int index)
@@ -262,7 +265,7 @@ static void reset(struct db_main *db)
 
 	// Initialize openCL tuning (library) for this format.
 	opencl_init_auto_setup(SEED, 1, split_events,
-	                       warn, 2, self,
+	                       warn, 3, self,
 	                       create_clobj, release_clobj,
 	                       2 * ocl_v_width * sizeof(wpapsk_state), 0, db);
 
@@ -280,27 +283,10 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 	scalar_gws = global_work_size * ocl_v_width;
 
 	// Copy data to gpu
-	if (new_keys) {
-		BENCH_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_in, CL_FALSE, 0, scalar_gws * 32, inbuffer, 0, NULL, multi_profilingEvent[0]), "Copy data to gpu");
-
-		// Call init kernel
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapmk_init, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[1]), "Run final kernel (MD5)");
-
-		new_keys = 0;
-	}
-
-	if (hccap.keyver == 0)
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_pmkid, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[2]), "Run final kernel (PMKID)");
-	else if (hccap.keyver == 1)
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_md5, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[2]), "Run final kernel (MD5)");
-	else if (hccap.keyver == 2)
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_sha1, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[2]), "Run final kernel (SHA1)");
-	else
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_sha256, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[2]), "Run final kernel (SHA256)");
-	BENCH_CLERROR(clFinish(queue[gpu_id]), "Failed running final kernel");
+	BENCH_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_in, CL_FALSE, 0, scalar_gws * 32, inbuffer, 0, NULL, multi_profilingEvent[0]), "Copy data to gpu");
 
-	// Read the result back
-	BENCH_CLERROR(clEnqueueReadBuffer(queue[gpu_id], mem_out, CL_TRUE, 0, sizeof(mic_t) * scalar_gws, mic, 0, NULL, multi_profilingEvent[3]), "Copy result back");
+	// Run kernel
+	BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapmk_init, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[1]), "Run initial kernel");
 
 	return count;
 }
@@ -320,9 +306,9 @@ struct fmt_main fmt_opencl_wpapsk_pmk = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		0,
+		FMT_BLOB,
 		{
-			"key version [0:PMKID 1:WPA 2:WPA2 3:802.11w]"
+			NULL // "key version [0:PMKID 1:WPA 2:WPA2 3:802.11w]"
 		},
 		{
 			FORMAT_TAG, ""
@@ -336,35 +322,29 @@ struct fmt_main fmt_opencl_wpapsk_pmk = {
 		valid,
 		fmt_default_split,
 		get_binary,
-		get_salt,
+		fmt_default_salt,
 		{
-			get_keyver,
+			NULL //get_keyver,
 		},
 		fmt_default_source,
 		{
-			fmt_default_binary_hash_0,
-			fmt_default_binary_hash_1,
-			fmt_default_binary_hash_2,
-			fmt_default_binary_hash_3,
-			fmt_default_binary_hash_4,
-			fmt_default_binary_hash_5,
-			fmt_default_binary_hash_6
+			binary_hash_0,
+			binary_hash_1,
+			binary_hash_2,
+			binary_hash_3,
+			binary_hash_4,
+			binary_hash_5,
+			binary_hash_6
 		},
-		salt_hash,
-		salt_compare,
-		set_salt,
+		fmt_default_salt_hash,
+		NULL,
+		fmt_default_set_salt,
 		set_key,
 		get_key,
 		fmt_default_clear_keys,
 		crypt_all,
 		{
-			get_hash_0,
-			get_hash_1,
-			get_hash_2,
-			get_hash_3,
-			get_hash_4,
-			get_hash_5,
-			get_hash_6
+			fmt_default_get_hash
 		},
 		cmp_all,
 		cmp_one,
diff --git a/src/opencl_wpapsk_fmt_plug.c b/src/opencl_wpapsk_fmt_plug.c
index 9d66009a62..5b26e62922 100644
--- a/src/opencl_wpapsk_fmt_plug.c
+++ b/src/opencl_wpapsk_fmt_plug.c
@@ -1,10 +1,8 @@
 /*
  * This software is Copyright (c) 2012 Lukas Odzioba <ukasz at openwall.net>
- * and Copyright (c) 2012-2018 magnum, and it is hereby released to the general
+ * and Copyright (c) 2012-2019 magnum, and it is hereby released to the general
  * public under the following terms: Redistribution and use in source and
  * binary forms, with or without modification, are permitted.
- *
- * Code was at some point based on Aircrack-ng source
  */
 #ifdef HAVE_OPENCL
 
@@ -25,7 +23,8 @@ john_register_one(&fmt_opencl_wpapsk);
 #include "unicode.h"
 #include "opencl_common.h"
 
-static cl_mem mem_in, mem_out, mem_salt, mem_state, pinned_in, pinned_out;
+static cl_mem mem_in, mem_salt, mem_state, mem_out, mem_data;
+static cl_mem pinned_in, pinned_out;
 static cl_kernel wpapsk_init, wpapsk_loop, wpapsk_pass2, wpapsk_final_md5, wpapsk_final_sha1, wpapsk_final_sha256, wpapsk_final_pmkid;
 static size_t key_buf_size;
 static unsigned int *inbuffer;
@@ -52,10 +51,6 @@ static struct fmt_main *self;
 /* This is faster but can't handle size 3 */
 //#define GETPOS(i, index)	(((index) & (ocl_v_width - 1)) * 4 + ((i) & ~3U) * ocl_v_width + (((i) & 3) ^ 3) + ((index) / ocl_v_width) * 64 * ocl_v_width)
 
-extern wpapsk_salt currentsalt;
-extern mic_t *mic;
-extern hccap_t hccap;
-
 typedef struct {
 	cl_uint W[5];
 	cl_uint ipad[5];
@@ -64,8 +59,12 @@ typedef struct {
 	cl_uint partial[5];
 } wpapsk_state;
 
+extern mic_t *mic;
+extern hccap_t hccap;
+
 static const char * warn[] = {
-	"xfer: ", ", init: ", ", loop: ", ", pass2: ", ", final: ", ", xfer: "
+	"xfer: ", ", init: ", ", loop: ", ", pass2: ",
+	", blob_xfer: ", ", final: ", ", xfer: "
 };
 
 static int split_events[] = { 2, -1, -1 };
@@ -106,8 +105,11 @@ static void create_clobj(size_t gws, struct fmt_main *self)
 	mem_state = clCreateBuffer(context[gpu_id], CL_MEM_READ_WRITE, sizeof(wpapsk_state) * gws, NULL, &ret_code);
 	HANDLE_CLERROR(ret_code, "Error allocating mem_state");
 
-	mem_salt = clCreateBuffer(context[gpu_id], CL_MEM_READ_ONLY | CL_MEM_COPY_HOST_PTR, sizeof(wpapsk_salt), &currentsalt, &ret_code);
-	HANDLE_CLERROR(ret_code, "Error allocating mem setting");
+	mem_salt = clCreateBuffer(context[gpu_id], CL_MEM_READ_ONLY | CL_MEM_ALLOC_HOST_PTR, sizeof(wpapsk_salt), NULL, &ret_code);
+	HANDLE_CLERROR(ret_code, "Error allocating mem salt");
+
+	mem_data = clCreateBuffer(context[gpu_id], CL_MEM_READ_ONLY | CL_MEM_ALLOC_HOST_PTR, sizeof(wpapsk_data), NULL, &ret_code);
+	HANDLE_CLERROR(ret_code, "Error allocating mem data");
 
 	pinned_out = clCreateBuffer(context[gpu_id], CL_MEM_WRITE_ONLY | CL_MEM_ALLOC_HOST_PTR, sizeof(mic_t) * gws, NULL, &ret_code);
 	HANDLE_CLERROR(ret_code, "Error allocating pinned out");
@@ -126,19 +128,19 @@ static void create_clobj(size_t gws, struct fmt_main *self)
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_pass2, 1, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_md5, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha1, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_sha256, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 0, sizeof(mem_state), &mem_state), "Error while setting mem_state kernel argument");
-	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 1, sizeof(mem_salt), &mem_salt), "Error while setting mem_salt kernel argument");
+	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 1, sizeof(mem_data), &mem_data), "Error while setting mem_data kernel argument");
 	HANDLE_CLERROR(clSetKernelArg(wpapsk_final_pmkid, 2, sizeof(mem_out), &mem_out), "Error while setting mem_out kernel argument");
 }
 
@@ -153,6 +155,7 @@ static void release_clobj(void)
 		HANDLE_CLERROR(clReleaseMemObject(pinned_out), "Release pinned_out");
 		HANDLE_CLERROR(clReleaseMemObject(mem_in), "Release pinned_in");
 		HANDLE_CLERROR(clReleaseMemObject(mem_out), "Release mem_out");
+		HANDLE_CLERROR(clReleaseMemObject(mem_data), "Release mem_data");
 		HANDLE_CLERROR(clReleaseMemObject(mem_salt), "Release mem_salt");
 		HANDLE_CLERROR(clReleaseMemObject(mem_state), "Release mem state");
 		mem_state = NULL;
@@ -180,7 +183,6 @@ static void done(void)
 
 static void clear_keys(void) {
 	memset(inbuffer, 0, key_buf_size);
-	new_keys = 1;
 }
 
 static void set_key(char *key, int index)
@@ -190,7 +192,6 @@ static void set_key(char *key, int index)
 
 	for (i = 0; i < length; i++)
 		((char*)inbuffer)[GETPOS(i, index)] = key[i];
-	new_keys = 1;
 }
 
 static char* get_key(int index)
@@ -296,40 +297,21 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 	BENCH_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_in, CL_FALSE, 0, scalar_gws * 64, inbuffer, 0, NULL, multi_profilingEvent[0]), "Copy data to gpu");
 
 	// Run kernel
-	if (new_keys || strcmp(last_ssid, hccap.essid) ||
-	    ocl_autotune_running || bench_or_test_running) {
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_init, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[1]), "Run initial kernel");
-
-		for (i = 0; i < (ocl_autotune_running ? 1 : ITERATIONS / HASH_LOOPS); i++) {
-			BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_loop, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[2]), "Run loop kernel");
-			BENCH_CLERROR(clFinish(queue[gpu_id]), "Error running loop kernel");
-			opencl_process_event();
-		}
-
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_pass2, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[3]), "Run intermediate kernel");
-
-		for (i = 0; i < (ocl_autotune_running ? 1 : ITERATIONS / HASH_LOOPS); i++) {
-			BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_loop, 1, NULL, &global_work_size, lws, 0, NULL, NULL), "Run loop kernel (2nd pass)");
-			BENCH_CLERROR(clFinish(queue[gpu_id]), "Error running loop kernel");
-			opencl_process_event();
-		}
-
-		new_keys = 0;
-		strcpy(last_ssid, hccap.essid);
+	BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_init, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[1]), "Run initial kernel");
+
+	for (i = 0; i < (ocl_autotune_running ? 1 : ITERATIONS / HASH_LOOPS); i++) {
+		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_loop, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[2]), "Run loop kernel");
+		BENCH_CLERROR(clFinish(queue[gpu_id]), "Error running loop kernel");
+		opencl_process_event();
 	}
 
-	if (hccap.keyver == 0)
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_pmkid, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[4]), "Run final kernel (PMKID)");
-	else if (hccap.keyver == 1)
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_md5, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[4]), "Run final kernel (MD5)");
-	else if (hccap.keyver == 2)
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_sha1, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[4]), "Run final kernel (SHA1)");
-	else
-		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_sha256, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[4]), "Run final kernel (SHA256)");
-	BENCH_CLERROR(clFinish(queue[gpu_id]), "Failed running final kernel");
+	BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_pass2, 1, NULL, &global_work_size, lws, 0, NULL, multi_profilingEvent[3]), "Run intermediate kernel");
 
-	// Read the result back
-	BENCH_CLERROR(clEnqueueReadBuffer(queue[gpu_id], mem_out, CL_TRUE, 0, sizeof(mic_t) * scalar_gws, mic, 0, NULL, multi_profilingEvent[5]), "Copy result back");
+	for (i = 0; i < (ocl_autotune_running ? 1 : ITERATIONS / HASH_LOOPS); i++) {
+		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_loop, 1, NULL, &global_work_size, lws, 0, NULL, NULL), "Run loop kernel (2nd pass)");
+		BENCH_CLERROR(clFinish(queue[gpu_id]), "Error running loop kernel");
+		opencl_process_event();
+	}
 
 	return count;
 }
@@ -341,7 +323,7 @@ struct fmt_main fmt_opencl_wpapsk = {
 		ALGORITHM_NAME,
 		BENCHMARK_COMMENT,
 		BENCHMARK_LENGTH,
-		8,
+		PLAINTEXT_MIN_LEN,
 		PLAINTEXT_LENGTH,
 		BINARY_SIZE,
 		BINARY_ALIGN,
@@ -349,9 +331,9 @@ struct fmt_main fmt_opencl_wpapsk = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_8_BIT | FMT_CASE,
+		FMT_8_BIT | FMT_CASE | FMT_BLOB,
 		{
-			"key version [0:PMKID 1:WPA 2:WPA2 3:802.11w]"
+			NULL // "key version [0:PMKID 1:WPA 2:WPA2 3:802.11w]"
 		},
 		{
 			FORMAT_TAG, ""
@@ -367,17 +349,17 @@ struct fmt_main fmt_opencl_wpapsk = {
 		get_binary,
 		get_salt,
 		{
-			get_keyver,
+			NULL //get_keyver,
 		},
 		fmt_default_source,
 		{
-			fmt_default_binary_hash_0,
-			fmt_default_binary_hash_1,
-			fmt_default_binary_hash_2,
-			fmt_default_binary_hash_3,
-			fmt_default_binary_hash_4,
-			fmt_default_binary_hash_5,
-			fmt_default_binary_hash_6
+			binary_hash_0,
+			binary_hash_1,
+			binary_hash_2,
+			binary_hash_3,
+			binary_hash_4,
+			binary_hash_5,
+			binary_hash_6
 		},
 		salt_hash,
 		salt_compare,
@@ -387,13 +369,7 @@ struct fmt_main fmt_opencl_wpapsk = {
 		clear_keys,
 		crypt_all,
 		{
-			get_hash_0,
-			get_hash_1,
-			get_hash_2,
-			get_hash_3,
-			get_hash_4,
-			get_hash_5,
-			get_hash_6
+			fmt_default_get_hash
 		},
 		cmp_all,
 		cmp_one,
diff --git a/src/wpapmk_fmt_plug.c b/src/wpapmk_fmt_plug.c
index 9a4e3609dd..2dbb4c7d72 100644
--- a/src/wpapmk_fmt_plug.c
+++ b/src/wpapmk_fmt_plug.c
@@ -115,11 +115,7 @@ static char* get_key(int index)
 
 static int crypt_all(int *pcount, struct db_salt *salt)
 {
-	const int count = *pcount;
-
-	wpapsk_postprocess(count);
-
-	return count;
+	return *pcount;
 }
 
 struct fmt_main fmt_wpapsk_pmk = {
@@ -137,9 +133,11 @@ struct fmt_main fmt_wpapsk_pmk = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_OMP,
+		FMT_OMP | FMT_BLOB,
 		{
-#if !AC_BUILT || HAVE_OPENSSL_CMAC_H
+#if 1
+			NULL
+#elif !AC_BUILT || HAVE_OPENSSL_CMAC_H
 			"key version [0:PMKID 1:WPA 2:WPA2 3:802.11w]"
 #else
 			"key version [0:PMKID 1:WPA 2:WPA2]"
@@ -158,35 +156,29 @@ struct fmt_main fmt_wpapsk_pmk = {
 		valid,
 		fmt_default_split,
 		get_binary,
-		get_salt,
+		fmt_default_salt,
 		{
-			get_keyver,
+			NULL //get_keyver,
 		},
 		fmt_default_source,
 		{
-			fmt_default_binary_hash_0,
-			fmt_default_binary_hash_1,
-			fmt_default_binary_hash_2,
-			fmt_default_binary_hash_3,
-			fmt_default_binary_hash_4,
-			fmt_default_binary_hash_5,
-			fmt_default_binary_hash_6
+			binary_hash_0,
+			binary_hash_1,
+			binary_hash_2,
+			binary_hash_3,
+			binary_hash_4,
+			binary_hash_5,
+			binary_hash_6
 		},
-		salt_hash,
-		salt_compare,
-		set_salt,
+		fmt_default_salt_hash,
+		NULL,
+		fmt_default_set_salt,
 		set_key,
 		get_key,
 		fmt_default_clear_keys,
 		crypt_all,
 		{
-			get_hash_0,
-			get_hash_1,
-			get_hash_2,
-			get_hash_3,
-			get_hash_4,
-			get_hash_5,
-			get_hash_6
+			fmt_default_get_hash,
 		},
 		cmp_all,
 		cmp_one,
diff --git a/src/wpapsk.h b/src/wpapsk.h
index b9479ef3f1..5d6333db9a 100644
--- a/src/wpapsk.h
+++ b/src/wpapsk.h
@@ -1,12 +1,13 @@
 /*
- * This software is Copyright (c) 2012 Lukas Odzioba <lukas dot odzioba at gmail dot com>
- * and Copyright (c) 2012-2018 magnum
+ * This software is
+ * Copyright (c) 2012 Lukas Odzioba <lukas dot odzioba at gmail dot com>
+ * and Copyright (c) 2012-2019 magnum
  * and it is hereby released to the general public under the following terms:
- * Redistribution and use in source and binary forms, with or without modification, are permitted.
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted.
  *
  * hccap format was introduced by oclHashcat-plus (now renamed to hashcat),
  * and it is described here: http://hashcat.net/wiki/hccap
- * Code is based on  Aircrack-ng source
  */
 #ifndef _WPAPSK_H
 #define _WPAPSK_H
@@ -27,19 +28,21 @@
 #include "base64_convert.h"
 #include "hccap.h"
 
-#define BINARY_SIZE		sizeof(mic_t)
-#define BINARY_ALIGN		4
+#define BINARY_SIZE			sizeof(fmt_data)
+#define BINARY_ALIGN		sizeof(size_t)
 #ifdef WPAPMK
 #define PLAINTEXT_MIN_LEN   64
 #define PLAINTEXT_LENGTH    64
 #define BENCHMARK_LENGTH    64
+#define SALT_SIZE           0
+#define SALT_ALIGN          MEM_ALIGN_NONE
 #else
 #define PLAINTEXT_MIN_LEN   8
 #define PLAINTEXT_LENGTH    63 /* We can do 64 but spec. says 63 */
 #define BENCHMARK_LENGTH    0x108
+#define SALT_SIZE		sizeof(wpapsk_salt)
+#define SALT_ALIGN		MEM_ALIGN_WORD
 #endif
-#define SALT_SIZE		(sizeof(hccap_t) - sizeof(mic_t))
-#define SALT_ALIGN		MEM_ALIGN_NONE
 #define BENCHMARK_COMMENT	""
 #define FORMAT_TAG           "$WPAPSK$"
 #define FORMAT_TAG_LEN       (sizeof(FORMAT_TAG)-1)
@@ -60,19 +63,22 @@ typedef struct {
 
 typedef struct {
 	uint32_t length;
+	uint8_t  essid[36]; // essid
+} wpapsk_salt;
+
 #ifdef JOHN_OCL_WPAPSK
-	uint8_t  eapol[256 + 64];
+typedef struct {
 	uint32_t eapol_size;
+	uint8_t  eapol[256 + 64];
 	uint8_t  data[64 + 12]; /* EAPOL data or PMKID */
+} wpapsk_data;
 #endif
-	uint8_t  salt[36]; // essid
-} wpapsk_salt;
 
 static struct fmt_tests tests[] = {
 #ifdef WPAPMK
 	{"$WPAPSK$test#..qHuv0A..ZPYJBRzZwAKpEXUJwpza/b69itFaq4.OWoGHfonpc13zCAUsRIfQN2Zar6EXp2BYcRuSkWEJIWjEJJvb4DWZCspbZ51.21.3zy.EY.6........../zZwAKpEXUJwpza/b69itFaq4.OWoGHfonpc13zCAUsQ..................................................................BoK.31m.E2..31m.U2..31m.U2..31m.U................................................................................................................................................................................/X.....E...AkkDQmDg9837LBHG.dGlKA", "cdd79a5acfb070c7e9d1023b870285d639e430b32f31aa37ac825a55b55524ee"},
 	{"$WPAPSK$Coherer#..l/Uf7J..qHUXMunTE3nfbMWSwxv27Ua0XutIOrfRSuv9gOCIugIVGlosMyXdNxfBZUAYmgKqeb6GBPxLiIZr56NtWTGR/Cp5ldAk61.5I0.Ec.2...........nTE3nfbMWSwxv27Ua0XutIOrfRSuv9gOCIugIVGlosM.................................................................3X.I.E..1uk0.E..1uk2.E..1uk0....................................................................................................................................................................................../t.....U...8FWdk8OpPckhewBwt4MXYI", "a288fcf0caaacda9a9f58633ff35e8992a01d9c10ba5e02efdf8cb5d730ce7bc"},
-#if (!AC_BUILT || HAVE_OPENSSL_CMAC_H) || defined(JOHN_OCL_WPAPMK)
+#if (!AC_BUILT || HAVE_OPENSSL_CMAC_H) || defined(JOHN_OCL_WPAPSK)
 	{"$WPAPSK$Neheb#g9a8Jcre9D0WrPnEN4QXDbA5NwAy5TVpkuoChMdFfL/8Dus4i/X.lTnfwuw04ASqHgvo12wJYJywulb6pWM6C5uqiMPNKNe9pkr6LE61.5I0.Eg.2..........1N4QXDbA5NwAy5TVpkuoChMdFfL/8Dus4i/X.lTnfwuw.................................................................3X.I.E..1uk2.E..1uk2.E..1uk4X...................................................................................................................................................................................../t.....k...0sHl.mVkiHW.ryNchcMd4g", "fb57668cd338374412c26208d79aa5c30ce40a110224f3cfb592a8f2e8bf53e8"},
 #endif
 	/* WPAPSK PMKID */
@@ -100,19 +106,15 @@ static struct fmt_tests tests[] = {
 
 /** Below are common variables used by wpapsk_fmt.c and opencl_wpapsk_fmt.c **/
 
-static hccap_t hccap;			///structure with hccap data
-static wpapsk_salt currentsalt;		///structure for essid
-static mic_t *mic;			///table for MIC keys
-#ifndef JOHN_OCL_WPAPSK
 #ifndef WPAPMK
-static wpapsk_password *inbuffer;	///table for candidate passwords
-#endif
-static wpapsk_hash *outbuffer;		///table for PMK calculated by GPU
+static wpapsk_salt *cur_salt;
 #endif
-
+static mic_t *mic;			// table for MIC keys
+#ifndef JOHN_OCL_WPAPSK
 #ifndef WPAPMK
-static int new_keys = 1;
-static char last_ssid[sizeof(hccap.essid)];
+static wpapsk_password *inbuffer;	// table for candidate passwords
+#endif
+static wpapsk_hash *outbuffer;		// table for calculated PMK
 #endif
 
 /** Below are common functions used by wpapsk_fmt.c and opencl_wpapsk_fmt.c **/
@@ -131,7 +133,7 @@ static hccap_t *decode_hccap(char *ciphertext)
 	memset(&hccap, 0, sizeof(hccap));
 	if (hash == NULL)
 		return &hccap;
-	while (essid != hash) {	///copy essid to hccap
+	while (essid != hash) {	// copy essid to hccap
 		*d++ = *essid++;
 	}
 	*d = '\0';
@@ -168,47 +170,113 @@ static hccap_t *decode_hccap(char *ciphertext)
 	return &hccap;
 }
 
+#ifdef WPAPSK_DEBUG
+static char *tomac(unsigned char *p) {
+	static char buf[48];
+	sprintf(buf, "%02X:%02X:%02X:%02X:%02X:%02X", p[0], p[1], p[2], p[3], p[4], p[5]);
+	return buf;
+}
+static char *hex(unsigned char *p, int len) {
+	static char buf[1024];
+	char *op=buf;
+	int i;
+	if (len > 32) {
+		do {
+			for (i = 0; i < 32; ++i) {
+				op += sprintf(op, "%02X", p[i]);
+				if (i<31&&i%4==3)
+					op += sprintf(op, " ");
+				if (i==15)
+					op += sprintf(op, ": ");
+			}
+			len -= 32;
+			p += 32;
+			op += sprintf(op, "\n          ");
+		} while (len > 32);
+	}
+	for (i = 0; i < len; ++i) {
+		op += sprintf(op, "%02X", p[i]);
+		if (i<31&&i%4==3)
+			op += sprintf(op, " ");
+		if (i==15)
+			op += sprintf(op, ": ");
+	}
+	return buf;
+}
+
+static void debug_hccap(hccap_t *hccap) {
+	printf("essid:    %s\n", hccap->essid);
+	printf("mac1:     %s\n", tomac(hccap->mac1));
+	printf("mac2:     %s\n", tomac(hccap->mac2));
+	printf("nonce1:   %s\n", hex(hccap->nonce1, 32));
+	printf("nonce2:   %s\n", hex(hccap->nonce2, 32));
+	printf("eapol:    %s\n", hex(hccap->eapol, 256));
+	printf("epol_sz:  %d (0x%02X)\n", hccap->eapol_size, hccap->eapol_size);
+	printf("keyver:   %d\n", hccap->keyver);
+	printf("keymic:   %s\n", hex(hccap->keymic, 16));
+}
+#endif
+
 static void *get_binary(char *ciphertext)
 {
-	static union {
-		unsigned char c[BINARY_SIZE];
-		uint32_t dummy;
-	} binary;
+	static fmt_data data;
+	hccap_t *s;
 
-	if (!strncmp(ciphertext, FORMAT_TAG, FORMAT_TAG_LEN)) {
-		hccap_t *hccap = decode_hccap(ciphertext);
+	data.flags = FMT_DATA_ALLOC;
+	data.size = sizeof(hccap_t);
+
+	s = (data.flags == FMT_DATA_TINY) ?
+		mem_alloc_tiny(data.size, sizeof(hccap_t*)) : mem_alloc(data.size);
+	data.blob = s;
 
-		memcpy(binary.c, hccap->keymic, BINARY_SIZE);
+	if (!strncmp(ciphertext, FORMAT_TAG, FORMAT_TAG_LEN)) {
+		memcpy(s, decode_hccap(ciphertext), sizeof(hccap_t));
 	} else {
-		base64_convert(ciphertext, e_b64_hex, 2 * BINARY_SIZE,
-		               binary.c, e_b64_raw, BINARY_SIZE,
+		memset(s, 0, sizeof(hccap_t));
+		s->keyver = 0;
+		base64_convert(ciphertext, e_b64_hex, 2 * sizeof(mic_t), s->keymic,
+		               e_b64_raw, sizeof(mic_t),
+		               flg_Base64_DONOT_NULL_TERMINATE, 0);
+		ciphertext += 33;
+		base64_convert(ciphertext, e_b64_hex, 12, s->mac1,
+		               e_b64_raw, 6,
+		               flg_Base64_DONOT_NULL_TERMINATE, 0);
+		ciphertext += 13;
+		base64_convert(ciphertext, e_b64_hex, 12, s->mac2,
+		               e_b64_raw, 6,
+		               flg_Base64_DONOT_NULL_TERMINATE, 0);
+		ciphertext += 13;
+		base64_convert(ciphertext, e_b64_hex, 64, s->essid,
+		               e_b64_raw, 33,
 		               flg_Base64_DONOT_NULL_TERMINATE, 0);
 	}
-	return binary.c;
+
+	return &data;
 }
 
+#ifndef WPAPMK
 static void *get_salt(char *ciphertext)
 {
-	static hccap_t s;
+	static wpapsk_salt salt;
+	hccap_t s;
 
 	if (!strncmp(ciphertext, FORMAT_TAG, FORMAT_TAG_LEN)) {
-		memcpy(&s, decode_hccap(ciphertext), SALT_SIZE);
+		memcpy(&s, decode_hccap(ciphertext), sizeof(hccap_t));
 	} else {
 		memset(&s, 0, sizeof(s));
-		s.keyver = 0;
 		ciphertext += 33;
-		base64_convert(ciphertext, e_b64_hex, 12, s.mac1, e_b64_raw, 6,
-		               flg_Base64_DONOT_NULL_TERMINATE, 0);
 		ciphertext += 13;
-		base64_convert(ciphertext, e_b64_hex, 12, s.mac2, e_b64_raw, 6,
-		               flg_Base64_DONOT_NULL_TERMINATE, 0);
 		ciphertext += 13;
 		base64_convert(ciphertext, e_b64_hex, 64, s.essid, e_b64_raw, 33,
 		               flg_Base64_DONOT_NULL_TERMINATE, 0);
 	}
 
-	return &s;
+	memcpy(salt.essid, s.essid, sizeof(salt.essid));
+	salt.length = strlen(s.essid);
+
+	return &salt;
 }
+#endif
 
 static int valid(char *ciphertext, struct fmt_main *self)
 {
@@ -266,7 +334,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 }
 
 #ifndef JOHN_OCL_WPAPSK
-static MAYBE_INLINE void prf_512(uint32_t * key, uint8_t * data, uint32_t * ret)
+static MAYBE_INLINE void prf_512(uint32_t *key, uint8_t *data, uint32_t *ret)
 {
 	char *text = (char*)"Pairwise key expansion";
 	unsigned char buff[100];
@@ -279,115 +347,44 @@ static MAYBE_INLINE void prf_512(uint32_t * key, uint8_t * data, uint32_t * ret)
 }
 #endif
 
-static void insert_mac(uint8_t * data)
+static void insert_mac(hccap_t *hccap, uint8_t *data)
 {
-	int k = memcmp(hccap.mac1, hccap.mac2, 6);
+	int k = memcmp(hccap->mac1, hccap->mac2, 6);
 	if (k > 0) {
-		memcpy(data, hccap.mac2, 6);
-		memcpy(data + 6, hccap.mac1, 6);
+		memcpy(data, hccap->mac2, 6);
+		memcpy(data + 6, hccap->mac1, 6);
 	} else {
-		memcpy(data, hccap.mac1, 6);
-		memcpy(data + 6, hccap.mac2, 6);
+		memcpy(data, hccap->mac1, 6);
+		memcpy(data + 6, hccap->mac2, 6);
 	}
 }
 
-static void insert_nonce(uint8_t * data)
+static void insert_nonce(hccap_t *hccap, uint8_t *data)
 {
-	int k = memcmp(hccap.nonce1, hccap.nonce2, 32);
+	int k = memcmp(hccap->nonce1, hccap->nonce2, 32);
 	if (k > 0) {
-		memcpy(data, hccap.nonce2, 32);
-		memcpy(data + 32, hccap.nonce1, 32);
+		memcpy(data, hccap->nonce2, 32);
+		memcpy(data + 32, hccap->nonce1, 32);
 	} else {
-		memcpy(data, hccap.nonce1, 32);
-		memcpy(data + 32, hccap.nonce2, 32);
+		memcpy(data, hccap->nonce1, 32);
+		memcpy(data + 32, hccap->nonce2, 32);
 	}
 }
 
-#ifdef WPAPSK_DEBUG
-static char *tomac(unsigned char *p) {
-	static char buf[48];
-	sprintf(buf, "%02X:%02X:%02X:%02X:%02X:%02X", p[0], p[1], p[2], p[3], p[4], p[5]);
-	return buf;
-}
-static char *hex(unsigned char *p, int len) {
-	static char buf[1024];
-	char *op=buf;
-	int i;
-	if (len > 32) {
-		do {
-			for (i = 0; i < 32; ++i) {
-				op += sprintf(op, "%02X", p[i]);
-				if (i<31&&i%4==3)
-					op += sprintf(op, " ");
-				if (i==15)
-					op += sprintf(op, ": ");
-			}
-			len -= 32;
-			p += 32;
-			op += sprintf(op, "\n          ");
-		} while (len > 32);
-	}
-	for (i = 0; i < len; ++i) {
-		op += sprintf(op, "%02X", p[i]);
-		if (i<31&&i%4==3)
-			op += sprintf(op, " ");
-		if (i==15)
-			op += sprintf(op, ": ");
-	}
-	return buf;
-}
-
-static void Debug_hccap() {
-	printf("essid:    %s\n", hccap.essid);
-	printf("mac1:     %s\n", tomac(hccap.mac1));
-	printf("mac2:     %s\n", tomac(hccap.mac2));
-	printf("nonce1:   %s\n", hex(hccap.nonce1, 32));
-	printf("nonce2:   %s\n", hex(hccap.nonce2, 32));
-	printf("eapol:    %s\n", hex(hccap.eapol, 256));
-	printf("epol_sz:  %d (0x%02X)\n", hccap.eapol_size, hccap.eapol_size);
-	printf("keyver:   %d\n", hccap.keyver);
-	printf("keymic:   %s\n", hex(hccap.keymic, 16));
-}
-#endif
-
+#ifndef WPAPMK
 static void set_salt(void *salt)
 {
-	memcpy(&hccap, salt, SALT_SIZE);
-	strncpy((char*)currentsalt.salt, hccap.essid, sizeof(currentsalt.salt));
-	currentsalt.length = strlen(hccap.essid);
+	cur_salt = salt;
 
 #ifdef JOHN_OCL_WPAPSK
-	currentsalt.eapol_size = hccap.eapol_size;
-	memcpy(currentsalt.eapol, hccap.eapol, hccap.eapol_size);
-	memset(currentsalt.eapol + hccap.eapol_size, 0x80, 1);
-	memset(currentsalt.eapol + hccap.eapol_size + 1, 0, 256 + 64 - hccap.eapol_size - 1);
-	if (hccap.keyver == 2)
-		alter_endianity(currentsalt.eapol, 256+56);
-	((unsigned int*)currentsalt.eapol)[16 * ((hccap.eapol_size + 8) / 64) + ((hccap.keyver == 1) ? 14 : 15)] = (64 + hccap.eapol_size) << 3;
-	if (hccap.keyver == 0) {
-		memcpy(currentsalt.data, "PMK Name", 8);
-		memcpy(currentsalt.data + 8, hccap.mac1, 6);
-		memcpy(currentsalt.data + 14, hccap.mac2, 6);
-		alter_endianity(currentsalt.data, 20);
-	} else {
-		insert_mac(currentsalt.data);
-		insert_nonce(currentsalt.data + 12);
-		if (hccap.keyver < 3)
-			alter_endianity(currentsalt.data, 64 + 12);
-	}
-
-	HANDLE_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_salt, CL_FALSE, 0, sizeof(wpapsk_salt), &currentsalt, 0, NULL, NULL), "Salt transfer");
+	HANDLE_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_salt, CL_FALSE, 0, sizeof(wpapsk_salt), cur_salt, 0, NULL, NULL), "Copy setting to gpu");
 	HANDLE_CLERROR(clFlush(queue[gpu_id]), "clFlush failed in set_salt()");
 #endif
-	//Debug_hccap();
 }
+#endif
 
 #ifndef JOHN_OCL_WPAPSK
 #ifndef WPAPMK
-static void clear_keys(void) {
-	new_keys = 1;
-}
-
 #undef set_key
 static void set_key(char *key, int index)
 {
@@ -396,7 +393,6 @@ static void set_key(char *key, int index)
 		length = PLAINTEXT_LENGTH;
 	inbuffer[index].length = length;
 	memcpy(inbuffer[index].v, key, length);
-	new_keys = 1;
 }
 
 static char *get_key(int index)
@@ -533,38 +529,37 @@ static void sha256_prf_bits(const u8 *key, size_t key_len, const char *label,
 
 /* Code borrowed from https://w1.fi/wpa_supplicant/ ends */
 
-static void wpapsk_postprocess(int keys)
+static int cmp_all(void *binary, int count)
 {
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
 	int i;
 	uint8_t data[64 + 12];
 
-	if (hccap.keyver == 0) {
+	if (hccap->keyver == 0) {
 		uint8_t msg[8 + 6 + 6] = "PMK Name";
 
-		memcpy(msg + 8, hccap.mac1, 6);
-		memcpy(msg + 14, hccap.mac2, 6);
+		memcpy(msg + 8, hccap->mac1, 6);
+		memcpy(msg + 14, hccap->mac2, 6);
 
 #ifdef _OPENMP
-#pragma omp parallel for default(none) private(i) shared(keys, outbuffer, msg, mic)
+#pragma omp parallel for default(none) private(i) shared(count, outbuffer, msg, mic)
 #endif
 		/* Create "keymic" that is actually PMKID */
-		for (i = 0; i < keys; i++) {
+		for (i = 0; i < count; i++) {
 			hmac_sha1((unsigned char*)outbuffer[i].v, 32,
-			          msg, 20,
-			          mic[i].keymic, 16);
+			          msg, 20, mic[i].keymic, 16);
 		}
-
-		return;
+	} else {
+		insert_mac(hccap, data);
+		insert_nonce(hccap, data + 12);
 	}
 
-	insert_mac(data);
-	insert_nonce(data + 12);
-
-	if (hccap.keyver == 1) {
+	if (hccap->keyver == 1) {
 #ifdef _OPENMP
-#pragma omp parallel for default(none) private(i) shared(keys, outbuffer, data, hccap, mic)
+#pragma omp parallel for default(none) private(i) shared(count, outbuffer, data, hccap, mic)
 #endif
-		for (i = 0; i < keys; i++) {
+		for (i = 0; i < count; i++) {
 			union {
 				uint32_t u32[20/4];
 				unsigned char uc[20];
@@ -574,26 +569,26 @@ static void wpapsk_postprocess(int keys)
 
 			prf_512(outbuffer[i].v, data, prf.u32); // PTK
 			hmac_md5_init_K16(prf.uc, &ctx);
-			hmac_md5_update(hccap.eapol, hccap.eapol_size, &ctx);
+			hmac_md5_update(hccap->eapol, hccap->eapol_size, &ctx);
 			hmac_md5_final(mic[i].keymic, &ctx);
 		}
-	} else if (hccap.keyver == 2) {
+	} else if (hccap->keyver == 2) {
 #ifdef _OPENMP
-#pragma omp parallel for default(none) private(i) shared(keys, outbuffer, data, hccap, mic)
+#pragma omp parallel for default(none) private(i) shared(count, outbuffer, data, hccap, mic)
 #endif
-		for (i = 0; i < keys; i++) {
+		for (i = 0; i < count; i++) {
 			uint32_t prf[20/4];
 
 			prf_512(outbuffer[i].v, data, prf); // PTK
-			hmac_sha1((unsigned char*)prf, 16, hccap.eapol,
-			          hccap.eapol_size, mic[i].keymic, 16);
+			hmac_sha1((unsigned char*)prf, 16, hccap->eapol,
+			          hccap->eapol_size, mic[i].keymic, 16);
 		}
 #if !AC_BUILT || HAVE_OPENSSL_CMAC_H
-	} else if (hccap.keyver == 3) { // 802.11w, WPA-PSK-SHA256
+	} else if (hccap->keyver == 3) { // 802.11w, WPA-PSK-SHA256
 #ifdef _OPENMP
-#pragma omp parallel for default(none) private(i) shared(keys, outbuffer, data, hccap, mic)
+#pragma omp parallel for default(none) private(i) shared(count, outbuffer, data, hccap, mic)
 #endif
-		for (i = 0; i < keys; i++) {
+		for (i = 0; i < count; i++) {
 			unsigned char ptk[48];
 			unsigned char cmic[16];
 			size_t miclen;
@@ -604,109 +599,201 @@ static void wpapsk_postprocess(int keys)
 			// Compute MIC
 			ctx = CMAC_CTX_new();
 			CMAC_Init(ctx, ptk, 16, EVP_aes_128_cbc(), 0);
-			CMAC_Update(ctx, hccap.eapol, hccap.eapol_size);
+			CMAC_Update(ctx, hccap->eapol, hccap->eapol_size);
 			CMAC_Final(ctx, cmic, &miclen);
 			memcpy(mic[i].keymic, cmic, 16);
 			CMAC_CTX_free(ctx);
 		}
 #endif /* HAVE_OPENSSL_CMAC_H */
 	}
-}
-#endif /* JOHN_OCL_WPAPSK */
 
-static int get_hash_0(int index)
-{
-	return mic[index].u32 & PH_MASK_0;
+	for (i = 0; i < count; i++)
+		if (!memcmp(hccap->keymic, mic[i].keymic, 16))
+			return 1;
+	return 0;
 }
 
-static int get_hash_1(int index)
+#else /* JOHN_OCL_WPAPSK */
+
+#ifdef WPAPMK
+#define EVENT(n) multi_profilingEvent[n]
+#else
+#define EVENT(n) multi_profilingEvent[n + 2]
+#endif
+
+static int cmp_all(void *binary, int count)
 {
-	return mic[index].u32 & PH_MASK_1;
+	wpapsk_data cur_data;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	int i;
+	size_t scalar_gws;
+	size_t *lws = local_work_size ? &local_work_size : NULL;
+
+	global_work_size = GET_NEXT_MULTIPLE(count, local_work_size);
+	scalar_gws = global_work_size * ocl_v_width;
+
+	cur_data.eapol_size = hccap->eapol_size;
+	memcpy(cur_data.eapol, hccap->eapol, hccap->eapol_size);
+	memset(cur_data.eapol + hccap->eapol_size, 0x80, 1);
+	memset(cur_data.eapol + hccap->eapol_size + 1, 0, 256 + 64 - hccap->eapol_size - 1);
+	if (hccap->keyver == 2)
+		alter_endianity(cur_data.eapol, 256+56);
+	((unsigned int*)cur_data.eapol)[16 * ((hccap->eapol_size + 8) / 64) + ((hccap->keyver == 1) ? 14 : 15)] = (64 + hccap->eapol_size) << 3;
+	if (hccap->keyver == 0) {
+		memcpy(cur_data.data, "PMK Name", 8);
+		memcpy(cur_data.data + 8, hccap->mac1, 6);
+		memcpy(cur_data.data + 14, hccap->mac2, 6);
+		alter_endianity(cur_data.data, 20);
+	} else {
+		insert_mac(hccap, cur_data.data);
+		insert_nonce(hccap, cur_data.data + 12);
+		if (hccap->keyver < 3)
+			alter_endianity(cur_data.data, 64 + 12);
+	}
+
+	// Copy non-hash data blob for this "binary"
+	HANDLE_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_data, CL_FALSE, 0, sizeof(wpapsk_data), &cur_data, 0, NULL, EVENT(2)), "Copy data to gpu");
+
+	if (hccap->keyver == 0)
+		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_pmkid, 1, NULL, &global_work_size, lws, 0, NULL, EVENT(3)), "Run final kernel (PMKID)");
+	else if (hccap->keyver == 1)
+		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_md5, 1, NULL, &global_work_size, lws, 0, NULL, EVENT(3)), "Run final kernel (MD5)");
+	else if (hccap->keyver == 2)
+		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_sha1, 1, NULL, &global_work_size, lws, 0, NULL, EVENT(3)), "Run final kernel (SHA1)");
+	else
+		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], wpapsk_final_sha256, 1, NULL, &global_work_size, lws, 0, NULL, EVENT(3)), "Run final kernel (SHA256)");
+	BENCH_CLERROR(clFinish(queue[gpu_id]), "Failed running final kernel");
+
+	// Read the result back
+	BENCH_CLERROR(clEnqueueReadBuffer(queue[gpu_id], mem_out, CL_TRUE, 0, sizeof(mic_t) * scalar_gws, mic, 0, NULL, EVENT(4)), "Copy result back");
+
+	for (i = 0; i < count; i++)
+		if (!memcmp(hccap->keymic, mic[i].keymic, 16))
+			return 1;
+	return 0;
 }
 
-static int get_hash_2(int index)
+#endif /* JOHN_OCL_WPAPSK */
+
+static int cmp_one(void *binary, int index)
 {
-	return mic[index].u32 & PH_MASK_2;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+
+	return !memcmp(hccap->keymic, mic[index].keymic, 16);
 }
 
-static int get_hash_3(int index)
+static int cmp_exact(char *source, int index)
 {
-	return mic[index].u32 & PH_MASK_3;
+	return 1;
 }
 
-static int get_hash_4(int index)
+static int binary_hash_0(void *binary)
 {
-	return mic[index].u32 & PH_MASK_4;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
+
+	memcpy(&mic, keymic, sizeof(uint32_t));
+
+	return mic & PH_MASK_0;
 }
 
-static int get_hash_5(int index)
+static int binary_hash_1(void *binary)
 {
-	return mic[index].u32 & PH_MASK_5;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
+
+	memcpy(&mic, keymic, sizeof(uint32_t));
+
+	return mic & PH_MASK_1;
 }
 
-static int get_hash_6(int index)
+static int binary_hash_2(void *binary)
 {
-	return mic[index].u32 & PH_MASK_6;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
+
+	memcpy(&mic, keymic, sizeof(uint32_t));
+
+	return mic & PH_MASK_2;
 }
 
-static int cmp_all(void *binary, int count)
+static int binary_hash_3(void *binary)
 {
-	uint32_t i, b = ((uint32_t *) binary)[0];
-	for (i = 0; i < count; i++) {
-		uint32_t *m = (uint32_t*) mic[i].keymic;
-		if (b == m[0])
-			return 1;
-	}
-	return 0;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
+
+	memcpy(&mic, keymic, sizeof(uint32_t));
+
+	return mic & PH_MASK_3;
 }
 
-static int cmp_one(void *binary, int index)
+static int binary_hash_4(void *binary)
 {
-	uint8_t i;
-	uint32_t *b = (uint32_t*) binary;
-	uint32_t *m = (uint32_t*) mic[index].keymic;
-	for (i = 0; i < BINARY_SIZE / 4; i++)
-		if (b[i] != m[i])
-			return 0;
-	return 1;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
+
+	memcpy(&mic, keymic, sizeof(uint32_t));
+
+	return mic & PH_MASK_4;
 }
 
-static int cmp_exact(char *source, int index)
+static int binary_hash_5(void *binary)
 {
-	return 1;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
+
+	memcpy(&mic, keymic, sizeof(uint32_t));
+
+	return mic & PH_MASK_5;
 }
 
-static int salt_hash(void *salt)
+static int binary_hash_6(void *binary)
 {
-	hccap_t *s = salt;
-	unsigned int mac1;
-	unsigned int mac2;
+	fmt_data *blob = binary;
+	hccap_t *hccap = blob->blob;
+	uint8_t *keymic = hccap->keymic;
+	uint32_t mic;
 
-	memcpy(&mac1, &s->mac1[2], 4);
-	memcpy(&mac2, &s->mac2[2], 4);
+	memcpy(&mic, keymic, sizeof(uint32_t));
 
-	return (mac1 + mac2) & (SALT_HASH_SIZE - 1);
+	return mic & PH_MASK_6;
 }
 
-static int salt_compare(const void *x, const void *y)
+#ifndef WPAPMK
+/*  Public domain hash function by DJ Bernstein (salt is an ESSID)   */
+/* Next after 5381 are 52711, 648391, 9737333, 174440041, 3657500101 */
+static int salt_hash(void *salt_s)
 {
-	int c = strncmp((const char*)x, (const char*)y, 36);
-	if (c) return c;
-	return memcmp((const char*)x, (const char*)y, SALT_SIZE);
+	wpapsk_salt *salt = salt_s;
+	unsigned int len = salt->length;
+	unsigned char *c = salt->essid;
+	unsigned int hash = 52711;
+
+	while (len--)
+		hash = ((hash << 5) + hash) ^ *c++;
+
+	return hash & (SALT_HASH_SIZE - 1);
 }
 
-/*
- * key version as first tunable cost
- * 0=PMKID
- * 1=WPA     (MD5)
- * 2=WPA2    (SHA1)
- * 3=802.11w (SHA256)
- */
-static unsigned int get_keyver(void *salt)
+static int salt_compare(const void *x, const void *y)
 {
-	hccap_t *my_salt = salt;
-
-	return (unsigned int) my_salt->keyver;
+	const wpapsk_salt *s1 = x, *s2 = y;
+	return strcmp((const char*)s1->essid, (const char*)s2->essid);
 }
+#endif /* WPAPMK */
 
-#endif
+#endif /* _WPAPSK_H */
diff --git a/src/wpapsk_fmt_plug.c b/src/wpapsk_fmt_plug.c
index 138d8e2ab3..9df7832824 100644
--- a/src/wpapsk_fmt_plug.c
+++ b/src/wpapsk_fmt_plug.c
@@ -1,5 +1,6 @@
 /*
- * This software is Copyright (c) 2012 Lukas Odzioba <ukasz at openwall dot net>,
+ * This software is
+ * Copyright (c) 2012 Lukas Odzioba <ukasz at openwall dot net>,
  * Copyright (c) 2012-2018 magnum,
  * and it is hereby released to the general public under the following terms:
  * Redistribution and use in source and binary forms, with or without
@@ -67,7 +68,7 @@ john_register_one(&fmt_wpapsk);
 
 extern wpapsk_password *inbuffer;
 extern wpapsk_hash *outbuffer;
-extern wpapsk_salt currentsalt;
+extern wpapsk_salt *cur_salt;
 extern hccap_t hccap;
 extern mic_t *mic;
 
@@ -111,7 +112,7 @@ static void done(void)
 
 #ifndef SIMD_COEF_32
 static MAYBE_INLINE void wpapsk_cpu(int count,
-    wpapsk_password * in, wpapsk_hash * out, wpapsk_salt * salt)
+    wpapsk_password *in, wpapsk_hash *out, wpapsk_salt *salt)
 {
 	int j;
 
@@ -121,13 +122,13 @@ static MAYBE_INLINE void wpapsk_cpu(int count,
 	for (j = 0; j < count; j++) {
 		pbkdf2_sha1((const unsigned char*)(in[j].v),
 		            in[j].length,
-		            salt->salt, salt->length,
+		            salt->essid, salt->length,
 		            4096, (unsigned char*)&out[j],
 		            32, 0);
 	}
 }
 #else
-static MAYBE_INLINE void wpapsk_sse(int count, wpapsk_password * in, wpapsk_hash * out, wpapsk_salt * salt)
+static MAYBE_INLINE void wpapsk_sse(int count, wpapsk_password *in, wpapsk_hash *out, wpapsk_salt *salt)
 {
 	int t; // thread count
 	int loops = (count+NBKEYS-1) / NBKEYS;
@@ -148,7 +149,7 @@ static MAYBE_INLINE void wpapsk_sse(int count, wpapsk_password * in, wpapsk_hash
 			x.pout[i] = &out[t*NBKEYS+i].v[0];
 		}
 		pbkdf2_sha1_sse((const unsigned char **)pin, lens,
-		                salt->salt, salt->length,
+		                salt->essid, salt->length,
 		                4096, &(x.poutc),
 		                32, 0);
 	}
@@ -159,17 +160,11 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 {
 	const int count = *pcount;
 
-	if (new_keys || strcmp(last_ssid, hccap.essid) || bench_or_test_running) {
 #ifndef SIMD_COEF_32
-		wpapsk_cpu(count, inbuffer, outbuffer, &currentsalt);
+	wpapsk_cpu(count, inbuffer, outbuffer, cur_salt);
 #else
-		wpapsk_sse(count, inbuffer, outbuffer, &currentsalt);
+	wpapsk_sse(count, inbuffer, outbuffer, cur_salt);
 #endif
-		new_keys = 0;
-		strcpy(last_ssid, hccap.essid);
-	}
-
-	wpapsk_postprocess(count);
 
 	return count;
 }
@@ -189,9 +184,11 @@ struct fmt_main fmt_wpapsk = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_CASE | FMT_8_BIT | FMT_OMP,
+		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_BLOB,
 		{
-#if !AC_BUILT || HAVE_OPENSSL_CMAC_H
+#if 1
+			NULL
+#elif !AC_BUILT || HAVE_OPENSSL_CMAC_H
 			"key version [0:PMKID 1:WPA 2:WPA2 3:802.11w]"
 #else
 			"key version [0:PMKID 1:WPA 2:WPA2]"
@@ -201,8 +198,7 @@ struct fmt_main fmt_wpapsk = {
 			FORMAT_TAG, ""
 		},
 		tests
-	},
-	{
+	}, {
 		init,
 		done,
 		fmt_default_reset,
@@ -212,33 +208,27 @@ struct fmt_main fmt_wpapsk = {
 		get_binary,
 		get_salt,
 		{
-			get_keyver,
+			NULL //get_keyver,
 		},
 		fmt_default_source,
 		{
-			fmt_default_binary_hash_0,
-			fmt_default_binary_hash_1,
-			fmt_default_binary_hash_2,
-			fmt_default_binary_hash_3,
-			fmt_default_binary_hash_4,
-			fmt_default_binary_hash_5,
-			fmt_default_binary_hash_6
+			binary_hash_0,
+			binary_hash_1,
+			binary_hash_2,
+			binary_hash_3,
+			binary_hash_4,
+			binary_hash_5,
+			binary_hash_6
 		},
 		salt_hash,
 		salt_compare,
 		set_salt,
 		set_key,
 		get_key,
-		clear_keys,
+		fmt_default_clear_keys,
 		crypt_all,
 		{
-			get_hash_0,
-			get_hash_1,
-			get_hash_2,
-			get_hash_3,
-			get_hash_4,
-			get_hash_5,
-			get_hash_6
+			fmt_default_get_hash
 		},
 		cmp_all,
 		cmp_one,
